import * as i0 from '@angular/core';
import { Injectable, Directive, Input, Component, ViewChild, EventEmitter, Output, ContentChildren, Pipe, NgModule } from '@angular/core';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i2$1 from '@angular/forms';
import { FormControl, Validators, FormGroup, FormsModule, ReactiveFormsModule } from '@angular/forms';
import 'reflect-metadata';
import { __decorate } from 'tslib';
import { of } from 'rxjs';
import * as i1 from '@angular/common/http';

class DynamicFormContextService {
    constructor() { }
    setContext(ctx) {
        this.context = ctx;
    }
    getContext() {
        return this.context;
    }
}
DynamicFormContextService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DynamicFormContextService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
DynamicFormContextService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DynamicFormContextService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DynamicFormContextService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return []; } });

class ButtonTemplateDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
    getTemplate() {
        return this.templateRef;
    }
}
ButtonTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ButtonTemplateDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
ButtonTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: ButtonTemplateDirective, selector: "[dfButton]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ButtonTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dfButton]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; } });

class InputTemplateDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
    getInputType() {
        return this.inputType.toUpperCase();
    }
    getTemplateRef() {
        return this.templateRef;
    }
}
InputTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InputTemplateDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
InputTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: InputTemplateDirective, selector: "[dfInputTemplate]", inputs: { inputType: "inputType" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InputTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dfInputTemplate]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; }, propDecorators: { inputType: [{
                type: Input,
                args: ['inputType']
            }] } });

class ObjectUtil {
    /**
     *Patches an object with some value
     *
     * @param {Object} obj
     * @param {Object} patch new state of some attributes
     * @returns {Object}
     */
    static patchObject(obj, patch) {
        let state = {};
        Object.entries(obj).forEach(([key, value]) => {
            if (obj[key] instanceof Object &&
                !(obj[key] instanceof Date) &&
                !Array.isArray(obj[key]) &&
                !(obj[key] instanceof Function)) {
                if (patch[key]) {
                    state[key] = ObjectUtil.patchObject(obj[key], patch[key]);
                }
                else {
                    state[key] = obj[key];
                }
            }
            else if (Array.isArray(obj[key])) {
                state[key] = patch[key] || obj[key];
            }
            else {
                state[key] = patch[key] || obj[key];
            }
        });
        return state;
    }
}

var InputTypes;
(function (InputTypes) {
    InputTypes["COMPOSITE"] = "COMPOSITE";
    InputTypes["TEXT"] = "TEXT";
    InputTypes["NUMBER"] = "NUMBER";
    InputTypes["DATE"] = "DATE";
    InputTypes["SELECT"] = "SELECT";
    InputTypes["CHECKBOX"] = "CHECKBOX";
    InputTypes["RADIO_BUTTONS"] = "RADIO_BUTTONS";
})(InputTypes || (InputTypes = {}));

var UpdateStrategy;
(function (UpdateStrategy) {
    UpdateStrategy["ON_CHANGE"] = "ON_CHANGE";
    UpdateStrategy["ON_PLUR"] = "ON_PLUR";
    UpdateStrategy["ON_SUBMIT"] = "ON_SUBMIT";
})(UpdateStrategy || (UpdateStrategy = {}));

class InputNodeImpl {
    /**
     *
     */
    constructor(properties, control, errorMap) {
        this.childNodes = null;
        this.control = control;
        this.properties = properties;
        this.errorMap = errorMap;
    }
    setProperties(map) {
        this.properties = map;
    }
    addProperty(key, value) {
        this.properties.set(key, value);
    }
    getProperty(key) {
        return this.properties.get(key);
    }
    setControl(control) {
        this.control = control;
    }
    getControl() {
        return this.control;
    }
    setErrorMap(map) {
        this.errorMap = map;
    }
    getError(key) {
        return this.errorMap.get(key);
    }
    addError(key, value) {
        this.errorMap.set(key, value);
    }
    addChild(node) {
        if (this.childNodes != null) {
            this.childNodes.push(node);
        }
        else {
            this.childNodes = [node];
        }
    }
    addChildren(nodes) {
        if (this.childNodes != null) {
            this.childNodes.push(...nodes);
        }
        else {
            this.childNodes = [...nodes];
        }
    }
    getChildren() {
        return this.childNodes;
    }
    hasChildren() {
        return this.childNodes ? true : false;
    }
    // enable
    // disable
    isValid() {
        return this.control.valid;
    }
    inValid() {
        return this.control.invalid;
    }
    isPending() {
        return this.control.pending;
    }
}

const INPUTS_METADATA_KEY = Symbol('InputsMetaData');
class InputsMetaData {
    static add(properties, target, propertyKey) {
        Reflect.defineMetadata(INPUTS_METADATA_KEY, InputsMetaData.propertiesToMap(properties), target, propertyKey);
    }
    static get(target, propertyKey) {
        return new Map(Reflect.getMetadata(INPUTS_METADATA_KEY, target, propertyKey));
    }
    static propertiesToMap(properties) {
        const propertiesMap = new Map();
        Object.entries(properties).forEach((entry) => {
            propertiesMap.set(entry[0], entry[1]);
        });
        return propertiesMap;
    }
}

class MapUtil {
    static formObject(obj) {
        const map = new Map();
        Object.entries(obj).forEach(keyValue => {
            map.set(keyValue[0], keyValue[1]);
        });
        return map;
    }
}

class FormMeta {
    constructor(formSpec) {
        this.name = formSpec === null || formSpec === void 0 ? void 0 : formSpec.name;
        this.actions = [];
        this.updateStrategy = formSpec.updateStrategy
            ? formSpec.updateStrategy
            : UpdateStrategy.ON_CHANGE;
    }
}

const FORM_METADATA_KEY = Symbol('FormSpec');
class FormMetaData {
    static add(formSpec, constructor) {
        Reflect.defineMetadata(FORM_METADATA_KEY, MapUtil.formObject(new FormMeta(formSpec)), constructor.prototype);
    }
    static get(target) {
        // console.log(target);
        // return Reflect.getMetadata(FORM_METADATA_KEY, target) as Map<string, any>;
        return new Map(Reflect.getMetadata(FORM_METADATA_KEY, target));
    }
}

const ACTION_METADATA_KEY = Symbol('actions');
class ActionsMetaData {
    static add(meta, constructor) {
        const actions = ActionsMetaData.get(constructor.prototype);
        if (actions) {
            actions.push(meta);
        }
        else {
            Reflect.defineMetadata(ACTION_METADATA_KEY, [meta], constructor.prototype);
        }
    }
    static get(target) {
        return Reflect.getMetadata(ACTION_METADATA_KEY, target);
    }
}

const CROSS_VALIDATION_METADATA_KEY = Symbol('CrossValidation');
class CrossValidationMeta {
    static add(spec, constructor) {
        const crossValidationMeta = Reflect.getMetadata(CROSS_VALIDATION_METADATA_KEY, constructor.prototype);
        if (!crossValidationMeta) {
            return Reflect.defineMetadata(CROSS_VALIDATION_METADATA_KEY, [spec], constructor.prototype);
        }
        else {
            crossValidationMeta.push(spec);
        }
    }
    static get(target) {
        return Reflect.getMetadata(CROSS_VALIDATION_METADATA_KEY, target);
    }
}

const ID_META_KEY = Symbol('Id');
const ON_CONTEXT_META_KEY = Symbol('ON_CONTEXT_META_KEY');
const USE_CONTEXT_META_KEY = Symbol('USE_CONTEXT_META');
/**
 * used to override some attributes in some context
 * a filed may be disabled in a context and enabled in another
 * or may have different style and so on ..
 *
 * @param specs {context: string;
  properties: OverridableProperties;}
 * @returns none
 */
function ContextOverride(specs) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(ON_CONTEXT_META_KEY, specs, target, propertyKey);
    };
}
function Id() {
    return function (target, propertyKey) {
        // console.log('target id', target);
        Reflect.defineMetadata(ID_META_KEY, propertyKey, target);
    };
}
/**
 * used to bind field existence with context variable
 * the field will only appear if its context equals form context
 * if no context is specified to field it appears in all contexts
 *
 * @param ctx string
 * @returns none
 */
function UseContext(ctx) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(USE_CONTEXT_META_KEY, ctx, target, propertyKey);
    };
}

const ASYNC_VALIDATION_METADATA_KEY = Symbol('AsyncValidationSpec');
class AsyncValidationMeta {
    static add(validationSpec, target, propertyKey) {
        const validationMeta = Reflect.getMetadata(ASYNC_VALIDATION_METADATA_KEY, target, propertyKey);
        if (validationMeta) {
            validationMeta.push(validationSpec);
        }
        else {
            Reflect.defineMetadata(ASYNC_VALIDATION_METADATA_KEY, [validationSpec], target, propertyKey);
        }
    }
    static get(target, propertyKey) {
        return Reflect.getMetadata(ASYNC_VALIDATION_METADATA_KEY, target, propertyKey);
    }
    static getValidatorsAndErrorMap(target, propertyKey) {
        // return Reflect.getMetadata(VALIDATION_METADATA_KEY, target, propertyKey) as ValidationSpec[] | undefined
        const validatorsAndErrorMap = {
            validators: new Array(),
            errorMap: new Map(),
        };
        const validationSpecs = AsyncValidationMeta.get(target, propertyKey);
        if (validationSpecs) {
            validationSpecs.forEach((spec) => {
                validatorsAndErrorMap.validators.push(spec.validator);
                validatorsAndErrorMap.errorMap.set(spec.errorName, spec.errorMessage);
            });
        }
        return validatorsAndErrorMap;
    }
}

const VALIDATION_METADATA_KEY = Symbol('ValidationSpec');
class ValidationsMetaData {
    static add(validationSpec, target, propertyKey) {
        const validationMeta = Reflect.getMetadata(VALIDATION_METADATA_KEY, target, propertyKey);
        if (validationMeta) {
            validationMeta.push(validationSpec);
        }
        else {
            Reflect.defineMetadata(VALIDATION_METADATA_KEY, [validationSpec], target, propertyKey);
        }
    }
    static get(target, propertyKey) {
        return Reflect.getMetadata(VALIDATION_METADATA_KEY, target, propertyKey);
    }
    static getValidatorsAndErrorMap(target, propertyKey) {
        // return Reflect.getMetadata(VALIDATION_METADATA_KEY, target, propertyKey) as ValidationSpec[] | undefined
        const validatorsAndErrorMap = {
            validators: new Array(),
            errorMap: new Map(),
        };
        const validationSpecs = ValidationsMetaData.get(target, propertyKey);
        if (validationSpecs) {
            validationSpecs.forEach((spec) => {
                validatorsAndErrorMap.validators.push(spec.validatorFn);
                validatorsAndErrorMap.errorMap.set(spec.errorName, spec.errorMessage);
            });
        }
        return validatorsAndErrorMap;
    }
}

class InputProcessorService {
    constructor(injector) {
        this.injector = injector;
    }
    process(entity, context, key) {
        const properties = InputsMetaData.get(entity, key) || new Map();
        const formControl = new FormControl(entity[key] //initialize
        );
        const errorMap = new Map();
        this.handleOnContextOverrideAndProcessProperties(entity, context, key, properties, errorMap, formControl);
        this.handleValidation(entity, context, key, properties, errorMap, formControl);
        this.handleAsyncValidation(entity, context, key, properties, errorMap, formControl);
        const inputNode = new InputNodeImpl(properties, formControl, errorMap);
        return inputNode;
    }
    /**
     *
     * @param entity
     * @param context
     * @param key
     * @param properties
     */
    handleOnContextOverrideAndProcessProperties(entity, context, key, properties, errorMap, control) {
        const contextSpecs = Reflect.getMetadata(ON_CONTEXT_META_KEY, entity, key);
        // console.log("ctx-specs", contextSpecs);
        if (contextSpecs && contextSpecs.context == context) {
            Object.entries(contextSpecs.properties).forEach(([k, v]) => {
                properties.set(k, v);
            });
        }
        if (properties.has('disabled') && properties.get('disabled') == true) {
            control.disable({ emitEvent: false });
        }
    }
    /**
     *
     * @param entity
     * @param context
     * @param key
     * @param properties
     * @param errorMap
     * @param control
     */
    handleValidation(entity, context, key, properties, errorMap, control) {
        const res = ValidationsMetaData.getValidatorsAndErrorMap(entity, key);
        // console.log('res', res);
        if (res.validators.includes(Validators.required)) {
            properties.set('required', true); // if required set required attribute
        }
        for (const entry of res.errorMap.entries()) {
            // console.log('entry',entry[0], entry[1]);
            errorMap.set(entry[0], entry[1]);
        }
        control.addValidators(res.validators);
    }
    /**
     *
     * @param entity
     * @param key
     * @param formControl
     * @param errorMap
     */
    handleAsyncValidation(entity, context, key, properties, errorMap, formControl) {
        // async validation
        const asyncValAndError = AsyncValidationMeta.getValidatorsAndErrorMap(entity, key);
        // console.log(asyncValAndError);
        asyncValAndError.validators.forEach((asyncVal) => {
            // console.log(asyncVal);
            if (asyncVal === null || asyncVal === void 0 ? void 0 : asyncVal.provider) {
                const injValidator = this.injector.get(asyncVal === null || asyncVal === void 0 ? void 0 : asyncVal.provider);
                // console.log('async validation processing', injValidator);
                formControl.addAsyncValidators(injValidator.validate);
                // formControl.updateValueAndValidity();
            }
            else if (asyncVal.validate) {
                formControl.addAsyncValidators(asyncVal.validate);
            }
            else if (typeof asyncVal == 'function') {
                formControl.addAsyncValidators(asyncVal);
            }
        });
        asyncValAndError.errorMap.forEach((value, key) => {
            errorMap.set(key, value);
        });
    }
}
InputProcessorService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InputProcessorService, deps: [{ token: i0.Injector }], target: i0.ɵɵFactoryTarget.Injectable });
InputProcessorService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InputProcessorService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InputProcessorService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i0.Injector }]; } });

class FormEntityProcessorService {
    constructor(inputProcessor) {
        this.inputProcessor = inputProcessor;
    }
    /**
     *Builds tree like structure from form entities
     *
     * @param formEntity class annotated with `FormEntity`
     * @param context `string` for proper usage please go to docs
     * @returns `InputNode` tree of input nodes
     */
    process(formEntity, context) {
        const root = this.parse(formEntity, context || '');
        this.processEnableFn(root); // this.handleEnableFn(node, (node.getControl() as FormGroup).getRawValue()); // should nt be here
        this.processOrder(root);
        return root;
    }
    /**
     * Used internally to build input nodes
     *
     * @param entity class annotated with `FormEntity`
     * @param context `string` for proper usage please go to docs
     * @param parentProperties `Map<string, any>`
     * @returns `InputNode`
     */
    parse(entity, context, parentProperties) {
        // handling actions meta data
        const formProperties = parentProperties || FormMetaData.get(entity);
        const actions = ActionsMetaData.get(entity);
        if (formProperties) {
            formProperties.set('actions', actions);
        }
        const childInputs = [];
        this.processUseContext(entity, context).forEach((key) => {
            if (this.isNotComposite(entity, key)) {
                const inputNode = this.inputProcessor.process(entity, context, key);
                childInputs.push(inputNode);
            }
            else if (this.isComposite(entity, key)) {
                const nestedFormNode = this.processNestedForm(entity, context, key, formProperties);
                childInputs.push(nestedFormNode);
            }
            else {
                // some fields have no meta data they must not be processed
            }
        });
        const fomGroupInitializer = {};
        childInputs.forEach((inputNode) => {
            fomGroupInitializer[inputNode.getProperty('name')] =
                inputNode.getControl();
        });
        const formNode = new InputNodeImpl(formProperties, new FormGroup(fomGroupInitializer, {
            updateOn: this.processUpdateStrategy(formProperties),
        }), new Map());
        formNode.addChildren(childInputs);
        this.processCrossValidation(entity, formNode);
        return formNode;
    }
    /**
     *Returns attributes within given context
     *
     * @param entity
     * @param context
     * @returns `string[]` attributes within context
     */
    processUseContext(entity, context) {
        const inContextAttrs = [];
        for (const key in entity) {
            const ctx = Reflect.getMetadata(USE_CONTEXT_META_KEY, entity, key);
            if (ctx && context && context != ctx) {
                // console.log('ctx ', ctx, 'context ', context);
                continue;
            }
            else {
                inContextAttrs.push(key);
            }
        }
        return inContextAttrs;
    }
    /**
     * Used internally to prepare nested form entity and its properties
     * to be used with `createNode`
     *
     * @param entity class with `@FormEntity`
     * @param context `string`
     * @param key `string`
     * @param formProperties parent form properties `Map<string, any>` current impl overrides nested form properties with its parent this may change in the future
     * @returns `InputNode` tree like that holds nodes
     */
    processNestedForm(entity, context, key, formProperties) {
        const properties = InputsMetaData.get(entity, key);
        const nestedFormEntity = new (properties.get('declaredClass'))();
        // initialize nested form entity values
        if (entity[key] != null) {
            Object.keys(entity[key]).forEach((k) => {
                nestedFormEntity[k] = entity[key][k];
            });
        }
        const nestedFormNode = this.parse(nestedFormEntity, context, new Map(formProperties));
        // fill node properties with nested form properties
        for (const propertyKeyValue of properties.entries()) {
            nestedFormNode.addProperty(propertyKeyValue[0], propertyKeyValue[1]);
        }
        // override nested form properties with its parent properties
        // warn??
        for (const propertyKeyValue of formProperties.entries()) {
            if (propertyKeyValue[0] != 'name' && propertyKeyValue[0] != 'action') {
                nestedFormNode.addProperty(propertyKeyValue[0], propertyKeyValue[1]);
            }
        }
        return nestedFormNode;
    }
    /**
     * Return qupdate strategy form mrta data if not set default `change`
     *
     * @param formProperties
     * @returns
     */
    processUpdateStrategy(formProperties) {
        // update strategy
        let updateOn;
        switch (formProperties.get('updateStrategy')) {
            case UpdateStrategy.ON_PLUR:
                updateOn = 'blur';
                break;
            case UpdateStrategy.ON_SUBMIT:
                updateOn = 'submit';
                break;
            default:
                updateOn = 'change';
                break;
        }
        return updateOn;
    }
    /**
     * Applies cross validation to form
     * @param entity
     * @param formNode
     */
    processCrossValidation(entity, formNode) {
        const crossValidators = CrossValidationMeta.get(entity);
        if (crossValidators && crossValidators.length > 0) {
            crossValidators.forEach((cv) => {
                formNode.getControl().addValidators([cv.validatorFn]);
                formNode.getControl().updateValueAndValidity();
            });
        }
        crossValidators === null || crossValidators === void 0 ? void 0 : crossValidators.forEach((validator) => {
            validator.effects.forEach((effect) => {
                var _a;
                const relatedInput = (_a = formNode
                    .getChildren()) === null || _a === void 0 ? void 0 : _a.find((i) => i.getProperty('name') == effect.input);
                relatedInput === null || relatedInput === void 0 ? void 0 : relatedInput.addError(validator.errorName, effect.message);
            });
        });
    }
    /**
     * Handles `enableFn` meta attribute
     * @param root `InputNode`
     */
    processEnableFn(root) {
        root === null || root === void 0 ? void 0 : root.getControl().valueChanges.subscribe((formValue) => {
            var _a;
            (_a = root.getChildren()) === null || _a === void 0 ? void 0 : _a.forEach((node) => {
                this.applyIfDefined(node, formValue);
            });
        });
    }
    /**
     * Used to apply `enableFn` after setting from value manually and silent change events
     * so keep it consistent
     *
     * @param root `InputNode`
     */
    applyEnableFn(root) {
        var _a;
        (_a = root.getChildren()) === null || _a === void 0 ? void 0 : _a.forEach((node) => {
            this.applyIfDefined(node, root.getControl().getRawValue());
        });
    }
    /**
     * Checks each field recursively to enable or disable it
     * if `enableFn` is defined on it
     *
     * @param root `InputNode`
     * @param formValue `Object`
     */
    applyIfDefined(node, formValue) {
        var _a, _b, _c;
        if (!node.hasChildren()) {
            if (node.getProperty('enableFn')) {
                switch (node.getProperty('enableFn')(formValue)) {
                    case true:
                        (_a = node.getControl()) === null || _a === void 0 ? void 0 : _a.enable({ emitEvent: false });
                        break;
                    case false:
                        (_b = node.getControl()) === null || _b === void 0 ? void 0 : _b.disable({ emitEvent: false });
                        break;
                }
            }
        }
        else {
            (_c = node.getChildren()) === null || _c === void 0 ? void 0 : _c.forEach((child) => {
                this.applyIfDefined(child, formValue[node.getProperty('name')]);
            });
        }
    }
    /**
     * Sorts inputs ASC based on `order` `property`
     * @param inputNode `InputNode`
     *
     */
    processOrder(inputNode) {
        var _a, _b;
        if (!inputNode.hasChildren()) {
            return;
        }
        else {
            (_a = inputNode
                .getChildren()) === null || _a === void 0 ? void 0 : _a.sort((a, b) => a.getProperty('order') - b.getProperty('order'));
            (_b = inputNode.getChildren()) === null || _b === void 0 ? void 0 : _b.forEach((child) => this.processOrder(child));
        }
    }
    isNotComposite(entity, key) {
        const properties = InputsMetaData.get(entity, key);
        return properties && (properties === null || properties === void 0 ? void 0 : properties.get('inputType')) != InputTypes.COMPOSITE
            ? true
            : false;
    }
    isComposite(entity, key) {
        const properties = InputsMetaData.get(entity, key);
        return properties && (properties === null || properties === void 0 ? void 0 : properties.get('inputType')) == InputTypes.COMPOSITE
            ? true
            : false;
    }
}
FormEntityProcessorService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: FormEntityProcessorService, deps: [{ token: InputProcessorService }], target: i0.ɵɵFactoryTarget.Injectable });
FormEntityProcessorService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: FormEntityProcessorService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: FormEntityProcessorService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: InputProcessorService }]; } });

class EntityRegistry {
    static add(name, declaredClass) {
        EntityRegistry.registry.set(name, declaredClass);
    }
    static get(name) {
        return EntityRegistry.registry.get(name);
    }
    get(name) {
        return EntityRegistry.registry.get(name);
    }
}
EntityRegistry.registry = new Map();
EntityRegistry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: EntityRegistry, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
EntityRegistry.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: EntityRegistry });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: EntityRegistry, decorators: [{
            type: Injectable
        }] });

class InputAnchorDirective {
    constructor(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
}
InputAnchorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InputAnchorDirective, deps: [{ token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Directive });
InputAnchorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: InputAnchorDirective, selector: "[dfInputAnchor]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InputAnchorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dfInputAnchor]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }]; } });

class InputComponentRegistry {
    static get(key) {
        return InputComponentRegistry.registeredInputs.get(key);
    }
    static set(key, component) {
        InputComponentRegistry.registeredInputs.set(key, component);
    }
}
InputComponentRegistry.registeredInputs = new Map();

class InputResolverComponent {
    constructor(resolver) {
        this.resolver = resolver;
        this.inputComponentsRegistry = InputComponentRegistry;
    }
    ngOnChanges(changes) { }
    ngOnInit() {
        if (!this.getTemplateRef()) {
            this.renderInputComponent();
        }
    }
    getInputNode() {
        return this.inputNode;
    }
    getTemplateRef() {
        return (this.inputTemplatesMap.get(this.inputNode.getProperty('inputType')) ||
            null);
    }
    getInputComponent() {
        return this.inputComponentsRegistry.get(this.inputNode.getProperty('inputType'));
    }
    renderInputComponent() {
        const inputComponent = this.getInputComponent();
        if (inputComponent) {
            const viewContainerRef = this.inputAnchor.viewContainerRef;
            viewContainerRef.clear();
            const componentFactoryResolver = this.resolver.resolveComponentFactory(inputComponent);
            const componentRef = viewContainerRef.createComponent(componentFactoryResolver);
            componentRef.instance.initialize(this.getInputNode());
        }
    }
}
InputResolverComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InputResolverComponent, deps: [{ token: i0.ComponentFactoryResolver }], target: i0.ɵɵFactoryTarget.Component });
InputResolverComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: InputResolverComponent, selector: "[df-input-resolver]", inputs: { inputNode: "inputNode", inputTemplatesMap: "inputTemplatesMap" }, viewQueries: [{ propertyName: "inputAnchor", first: true, predicate: InputAnchorDirective, descendants: true, static: true }], usesOnChanges: true, ngImport: i0, template: "<ng-container\n  *ngIf=\"getTemplateRef()\"\n  [ngTemplateOutlet]=\"getTemplateRef()\"\n  [ngTemplateOutletContext]=\"{ $implicit: getInputNode() }\"\n></ng-container>\n\n<ng-template dfInputAnchor></ng-template>\n", styles: [""], directives: [{ type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: InputAnchorDirective, selector: "[dfInputAnchor]" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InputResolverComponent, decorators: [{
            type: Component,
            args: [{
                    selector: '[df-input-resolver]',
                    templateUrl: './input-resolver.component.html',
                    styleUrls: ['./input-resolver.component.css'],
                    // changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: function () { return [{ type: i0.ComponentFactoryResolver }]; }, propDecorators: { inputNode: [{
                type: Input
            }], inputTemplatesMap: [{
                type: Input
            }], inputAnchor: [{
                type: ViewChild,
                args: [InputAnchorDirective, { static: true }]
            }] } });

class DynamicFormComponent {
    constructor(formEntityProcessorService, dynamicFormContextService, entityRegistry) {
        this.formEntityProcessorService = formEntityProcessorService;
        this.dynamicFormContextService = dynamicFormContextService;
        this.entityRegistry = entityRegistry;
        this.includeDisabled = false; // todo add in documentation
        this.submitEvent = new EventEmitter();
        this.changEvent = new EventEmitter();
        this.buttonClickEvent = new EventEmitter();
        this.inputTemplateMap = new Map();
    }
    ngAfterContentInit() {
        // console.log('buttonTemplateQueryList', this.buttonTemplateQueryList);
        this.inputTemplateQueryList.forEach((item) => {
            this.inputTemplateMap.set(item.getInputType(), item.getTemplateRef());
        });
    }
    ngOnInit() { }
    ngOnChanges(changes) {
        var _a;
        if (changes.entityName) {
            const entityClass = this.entityRegistry.get(changes.entityName.currentValue);
            if (entityClass) {
                this.formEntity = new entityClass();
                this.inputTree = this.formEntityProcessorService.process(this.formEntity, this.useContext);
                console.log(this.inputTree);
                this.dynamicFormContextService.setContext(this.inputTree.getControl().value);
                this.inputTree.getControl().valueChanges.subscribe((val) => {
                    this.dynamicFormContextService.setContext(val);
                });
                (_a = this.inputTree.getControl()) === null || _a === void 0 ? void 0 : _a.valueChanges.subscribe((value) => {
                    this.changEvent.emit(value);
                });
                // check  enabled ot disabled status
                this.formEntityProcessorService.applyEnableFn(this.inputTree);
            }
        }
        if (changes.initialValue && changes.initialValue.currentValue) {
            let value = changes.initialValue.currentValue;
            this.inputTree.getControl().reset(value, { emitEvent: false });
            // update value and checks for validation its important to start with valid data
            this.inputTree.getControl().updateValueAndValidity();
            // check  enabled ot disabled status
            this.formEntityProcessorService.applyEnableFn(this.inputTree);
        }
    }
    onSubmit(v) {
        var _a, _b;
        (_a = this.inputTree.getControl()) === null || _a === void 0 ? void 0 : _a.markAllAsTouched();
        // console.log(this.inputTree.getControl());
        if ((_b = this.inputTree.getControl()) === null || _b === void 0 ? void 0 : _b.valid) {
            this.submitEvent.emit(this.formValue);
        }
    }
    onClick(action) {
        if (action.type == 'button') {
            this.buttonClickEvent.emit({
                actionId: action.id,
                formValue: this.formValue,
            });
        }
        else if (typeof action == 'string') {
            this.buttonClickEvent.emit({
                actionId: action,
                formValue: this.formValue,
            });
        }
    }
    get formValue() {
        if (this.includeDisabled) {
            return this.valueTransformer
                ? this.valueTransformer.transform(this.inputTree.getControl().getRawValue())
                : this.inputTree.getControl().getRawValue();
        }
        else {
            return this.valueTransformer
                ? this.valueTransformer.transform(this.inputTree.getControl().value)
                : this.inputTree.getControl().value;
        }
    }
    markAllAsTouched() {
        var _a;
        (_a = this.inputTree.getControl()) === null || _a === void 0 ? void 0 : _a.markAllAsTouched();
    }
    markAsTouched(path) {
        throw new Error('Method not implemented.');
    }
    markAsInvalid(path, errConfig) {
        throw new Error('Method not implemented.');
    }
    markFieldAsInvalid(path, errConfig) {
        throw new Error('Method not implemented.');
    }
    disable(path) {
        throw new Error('Method not implemented.');
    }
    enable(path) {
        throw new Error('Method not implemented.');
    }
    setReadonly(path) {
        throw new Error('Method not implemented.');
    }
    unsetReadonly(path) {
        throw new Error('Method not implemented.');
    }
    getRowValue() {
        return this.inputTree.getControl().getRawValue();
    }
    getValue() {
        return this.inputTree.getControl().value;
    }
    fireAction(id) {
        throw new Error('Method not implemented.');
    }
    reset(value, emitEvent) {
        this.inputTree.getControl().reset(value || {}, { emitEvent: emitEvent });
    }
    patch(value, emitEvent) {
        this.inputTree
            .getControl()
            .reset(ObjectUtil.patchObject(this.inputTree.getControl().getRawValue(), value), {
            emitEvent: emitEvent,
        });
    }
    getName() {
        return this.entityName;
    }
    isValid() {
        return this.inputTree.getControl().valid;
    }
}
DynamicFormComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DynamicFormComponent, deps: [{ token: FormEntityProcessorService }, { token: DynamicFormContextService }, { token: EntityRegistry }], target: i0.ɵɵFactoryTarget.Component });
DynamicFormComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: DynamicFormComponent, selector: "d-form", inputs: { entityName: "entityName", initialValue: "initialValue", useContext: "useContext", valueTransformer: "valueTransformer", includeDisabled: "includeDisabled" }, outputs: { submitEvent: "submitEvent", changEvent: "changeEvent", buttonClickEvent: "buttonClickEvent" }, providers: [DynamicFormContextService], queries: [{ propertyName: "inputTemplateQueryList", predicate: InputTemplateDirective }, { propertyName: "buttonTemplateQueryList", predicate: ButtonTemplateDirective }], usesOnChanges: true, ngImport: i0, template: "<form\n  *ngIf=\"inputTree\"\n  class=\"row g-3 d-form\"\n  [formGroup]=\"$any(inputTree!.getControl())\"\n  (ngSubmit)=\"onSubmit($event)\"\n>\n  <ng-container *ngFor=\"let inputNode of inputTree.getChildren()\">\n    <!-- <div\n      lib-dynamic-form-input\n      [inputNode]=\"inputNode\"\n      [class]=\"'col-md-' + inputNode.getProperty('width')\"\n    ></div> -->\n\n    <div\n      [class]=\"'col-md-' + inputNode.getProperty('width')\"\n      df-input-resolver\n      [inputNode]=\"inputNode\"\n      [inputTemplatesMap]=\"inputTemplateMap\"\n    ></div>\n  </ng-container>\n\n  <div class=\"col-12 d-buttons-row\">\n    <ng-container\n      *ngIf=\"buttonTemplateQueryList.length > 0; else actionsFromMeta\"\n    >\n      <ng-container\n        *ngFor=\"let buttonDir of buttonTemplateQueryList\"\n        [ngTemplateOutlet]=\"buttonDir.getTemplate()\"\n        [ngTemplateOutletContext]=\"{ $implicit: inputTree }\"\n      ></ng-container>\n    </ng-container>\n    <ng-template #actionsFromMeta>\n      <div\n        class=\"col-lg-1 col-md-3 col-sm-3\"\n        *ngFor=\"let action of inputTree.getProperty('actions')\"\n      >\n        <button\n          [type]=\"action.type\"\n          [class]=\"'d-form-btn ' + (action.class || 'btn btn-primary')\"\n          (click)=\"onClick(action)\"\n        >\n          {{ action?.label }}\n        </button>\n      </div>\n    </ng-template>\n  </div>\n</form>\n<ng-content></ng-content>\n", styles: [""], components: [{ type: InputResolverComponent, selector: "[df-input-resolver]", inputs: ["inputNode", "inputTemplatesMap"] }], directives: [{ type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2$1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i2$1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i2$1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DynamicFormComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'd-form',
                    templateUrl: './dynamic-form.component.html',
                    styleUrls: ['./dynamic-form.component.css'],
                    providers: [DynamicFormContextService],
                }]
        }], ctorParameters: function () { return [{ type: FormEntityProcessorService }, { type: DynamicFormContextService }, { type: EntityRegistry }]; }, propDecorators: { entityName: [{
                type: Input,
                args: ['entityName']
            }], initialValue: [{
                type: Input,
                args: ['initialValue']
            }], useContext: [{
                type: Input,
                args: ['useContext']
            }], valueTransformer: [{
                type: Input,
                args: ['valueTransformer']
            }], includeDisabled: [{
                type: Input,
                args: ['includeDisabled']
            }], submitEvent: [{
                type: Output,
                args: ['submitEvent']
            }], changEvent: [{
                type: Output,
                args: ['changeEvent']
            }], buttonClickEvent: [{
                type: Output,
                args: ['buttonClickEvent']
            }], inputTemplateQueryList: [{
                type: ContentChildren,
                args: [InputTemplateDirective]
            }], buttonTemplateQueryList: [{
                type: ContentChildren,
                args: [ButtonTemplateDirective]
            }] } });

class MessageStringInterpolation {
    // private readonly  interpolation_pattern = /\${([^\${}]*)}/g;
    static interpolate(message, obj) {
        // @ts-ignore
        return message.replace(/\${([^\${}]*)}/g, (a, b) => {
            // @ts-ignore
            let r = obj[b];
            // console.log("interpolate", a, b, obj);
            return typeof r === 'string' || typeof r === 'number' ? r : r.toString(); //a;
        });
    }
}

class ErrorMessagePipe {
    transform(value) {
        const validationError = value.getControl().errors;
        if (validationError) {
            let errorString = null;
            const key = Object.keys(validationError)[0];
            errorString = value.getError(key) || '';
            return MessageStringInterpolation.interpolate(errorString || '', validationError[key]);
        }
        else {
            return null;
        }
    }
}
ErrorMessagePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ErrorMessagePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
ErrorMessagePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ErrorMessagePipe, name: "errorMessage", pure: false });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ErrorMessagePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'errorMessage',
                    pure: false,
                }]
        }] });

class InputComponent {
    constructor() { }
    ngOnInit() { }
    getInputNode() {
        return this.inputNode;
    }
    initialize(input) {
        this.inputNode = input;
        this.value = this.getValue();
        this.onChange();
    }
    setValue(val) {
        this.inputNode
            .getControl()
            .setValue(val, { self: false, emitEvent: false });
    }
    commitChanges() {
        this.inputNode.getControl().updateValueAndValidity();
    }
    getValue() {
        return this.inputNode.getControl().value;
    }
    onChange() {
        this.inputNode.getControl().valueChanges.subscribe((val) => {
            if (JSON.stringify(val) == JSON.stringify(this.value)) {
                return;
            }
            else {
                this.value = val;
            }
        });
    }
}
InputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InputComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
InputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: InputComponent, selector: "[lib-input]", ngImport: i0, template: "<div>welcome input component</div>\n\n<!-- <ng-container\n  *ngIf=\"\n    inputDescription.getProperty('inputType') == INPUT_TYPES.TEXT ||\n    inputDescription.getProperty('inputType') == INPUT_TYPES.NUMBER ||\n    inputDescription.getProperty('inputType') == INPUT_TYPES.DATE\n  \"\n>\n  <div [class]=\"inputContainerClasses\">\n    <label\n      *ngIf=\"!isFloatingLabel\"\n      [attr.for]=\"inputDescription.getProperty('id')\"\n      [ngClass]=\"labelClasses\"\n      [ngClass]=\"{\n        'required-control-label': inputDescription.getProperty('required'),\n        'invalid-label':\n          inputDescription.getControl()?.touched &&\n          inputDescription.getControl()?.invalid\n      }\"\n      >{{ inputDescription.getProperty(\"label\") }}</label\n    >\n    <div [class]=\"inputDivClasses\">\n      <input\n        class=\"form-control\"\n        [ngClass]=\"{\n          'is-invalid':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        [placeholder]=\"inputDescription.getProperty('placeHolder') || ''\"\n        [id]=\"inputDescription.getProperty('id')\"\n        [type]=\"inputDescription.getProperty('type')\"\n        [formControl]=\"$any(inputDescription.getControl())\"\n        [name]=\"inputDescription.getProperty('name')\"\n        [attr.readonly]=\"inputDescription.getProperty('readonly')\"\n      />\n\n      <label\n        *ngIf=\"isFloatingLabel\"\n        [attr.for]=\"inputDescription.getProperty('id')\"\n        [ngClass]=\"{\n          'required-control-label': inputDescription.getProperty('required'),\n          'invalid-label':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        >{{ inputDescription.getProperty(\"label\") }}</label\n      >\n      <div\n        class=\"invalid-feedback\"\n        *ngIf=\"\n          inputDescription.getControl()?.touched &&\n          inputDescription.getControl()?.invalid\n        \"\n      >\n        {{ inputDescription | errorMessage }}\n      </div>\n    </div>\n  </div>\n</ng-container> -->\n\n<!-- \n<ng-container\n  *ngIf=\"inputDescription.getProperty('inputType') == INPUT_TYPES.SELECT\"\n>\n  <div [class]=\"inputContainerClasses\">\n    <label\n      *ngIf=\"!isFloatingLabel\"\n      [attr.for]=\"inputDescription.getProperty('id')\"\n      [ngClass]=\"labelClasses\"\n      [ngClass]=\"{\n        'required-control-label': inputDescription.getProperty('required'),\n        'invalid-label':\n          inputDescription.getControl()?.touched &&\n          inputDescription.getControl()?.invalid\n      }\"\n      >{{ inputDescription.getProperty(\"label\") }}</label\n    >\n    <div [class]=\"inputDivClasses\">\n      <select\n        class=\"form-select\"\n        [ngClass]=\"{\n          'is-invalid':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        [id]=\"inputDescription.getProperty('id')\"\n        [formControl]=\"$any(inputDescription.getControl())\"\n        [name]=\"inputDescription.getProperty('name')\"\n        [compareWith]=\"inputDescription.getProperty('compareWith')\"\n      >\n        <option\n          *ngFor=\"\n            let opt of dataLoader.load(\n              inputDescription.getProperty('dataSource')\n            ) | async\n          \"\n          [ngValue]=\"\n            opt[inputDescription.getProperty('bindValue')]\n              ? opt[inputDescription.getProperty('bindValue')]\n              : opt\n          \"\n        >\n          {{ opt[inputDescription.getProperty(\"bindLabel\")] }}\n        </option>\n      </select>\n      <label\n        *ngIf=\"isFloatingLabel\"\n        [attr.for]=\"inputDescription.getProperty('id')\"\n        [ngClass]=\"{\n          'required-control-label': inputDescription.getProperty('required'),\n          'invalid-label':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        >{{ inputDescription.getProperty(\"label\") }}</label\n      >\n      <div\n        class=\"invalid-feedback\"\n        *ngIf=\"\n          inputDescription.getControl()?.touched &&\n          inputDescription.getControl()?.invalid\n        \"\n      >\n        {{ inputDescription | errorMessage }}\n      </div>\n    </div>\n  </div>\n</ng-container> -->\n\n<!-- <ng-container\n  *ngIf=\"inputDescription.getProperty('inputType') == INPUT_TYPES.CHECKBOX\"\n>\n  <div [class]=\"inputContainerClasses\">\n    <div class=\"form-check\">\n      <input\n        class=\"form-check-input\"\n        [ngClass]=\"{\n          'is-invalid':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        [id]=\"inputDescription.getProperty('id')\"\n        type=\"checkbox\"\n        [formControl]=\"$any(inputDescription.getControl())\"\n        [name]=\"inputDescription.getProperty('name')\"\n      />\n      <label\n        [attr.for]=\"inputDescription.getProperty('id')\"\n        class=\"form-check-label\"\n        [ngClass]=\"{\n          'required-control-label': inputDescription.getProperty('required'),\n          'invalid-label':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        >{{ inputDescription.getProperty(\"label\") }}</label\n      >\n      <div\n        class=\"invalid-feedback\"\n        *ngIf=\"\n          inputDescription.getControl()?.touched &&\n          inputDescription.getControl()?.invalid\n        \"\n      >\n        {{ inputDescription | errorMessage }}\n      </div>\n    </div>\n  </div>\n</ng-container> -->\n\n<!-- <ng-container\n  *ngIf=\"inputDescription.getProperty('inputType') == INPUT_TYPES.RADIO_BUTTONS\"\n>\n  <fieldset class=\"row mt-3 mb-3\">\n    <legend [ngClass]=\"radioLegendClasses\" class=\"col-form-label\">\n      {{ inputDescription.getProperty(\"legend\") }}\n    </legend>\n\n  \n    <div [ngClass]=\"radioInputContainerClasses\">\n      <div class=\"row mt-1 mb-1\">\n        <div\n          [class]=\"'col-sm-' + inputDescription.getProperty('inputWidth')\"\n          *ngFor=\"\n            let opt of dataLoader.load(\n              inputDescription.getProperty('dataSource')\n            ) | async;\n            let i = index\n          \"\n        >\n          <input\n            class=\"form-check-input mr-50\"\n            [id]=\"inputDescription.getProperty('id') + i\"\n            type=\"radio\"\n            [formControl]=\"$any(inputDescription.getControl())\"\n            [value]=\"\n              inputDescription.getProperty('bindValue')\n                ? opt[inputDescription.getProperty('bindValue')]\n                : opt\n            \"\n            [name]=\"inputDescription.getProperty('name')\"\n          />\n          <label\n            class=\"form-check-label\"\n            [attr.for]=\"inputDescription.getProperty('id') + i\"\n          >\n            {{ opt[inputDescription.getProperty(\"bindLabel\")] }}\n          </label>\n        </div>\n      </div>\n    </div>\n  </fieldset>\n</ng-container> -->\n\n<!-- <ng-container\n  *ngIf=\"inputDescription.getProperty('inputType') == INPUT_TYPES.COMPOSITE\"\n>\n  <fieldset class=\"row g-3\">\n    <legend [ngClass]=\"compositeLegendClasses\" class=\"col-form-label\">\n      {{ inputDescription.getProperty(\"legend\") }}\n    </legend>\n\n    <div [ngClass]=\"compositeInputContainerClasses\">\n      <div class=\"row g-3\">\n        <ng-container *ngFor=\"let childInput of inputDescription.getChildren()\">\n          <div\n            lib-input\n            [inputDescription]=\"childInput\"\n            [labelStyling]=\"inputDescription.getProperty('labelStyling')\"\n            [class]=\"'col-md-' + childInput.getProperty('width')\"\n          ></div>\n        </ng-container>\n      </div>\n    </div>\n  </fieldset>\n\n  \n</ng-container> -->\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InputComponent, decorators: [{
            type: Component,
            args: [{
                    selector: '[lib-input]',
                    templateUrl: './input.component.html',
                    styleUrls: ['./input.component.css'],
                }]
        }], ctorParameters: function () { return []; } });

function DynamicFormInput(specs) {
    return function (constructor) {
        if (specs.inputType.toUpperCase() == InputTypes.COMPOSITE &&
            InputComponentRegistry.get(InputTypes.COMPOSITE)) {
            console.error("can't set inputType to 'COMPOSITE' its reserved for internal use, " +
                'correct inputType in DynamicFormInput(specs: { inputType: string }) for class ' +
                constructor);
            return constructor;
        }
        InputComponentRegistry.set(specs.inputType.toUpperCase(), constructor);
        return constructor;
    };
}

let DateInputComponent = class DateInputComponent extends InputComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
};
DateInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DateInputComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DateInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: DateInputComponent, selector: "lib-date-input", usesInheritance: true, ngImport: i0, template: "<label\n  [attr.for]=\"getInputNode().getProperty('id')\"\n  class=\"d-form-label form-label\"\n  [ngClass]=\"{\n    required: getInputNode().getProperty('required'),\n    'invalid-label':\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid\n  }\"\n  >{{ getInputNode().getProperty(\"label\") }}\n</label>\n<input\n  class=\"form-control d-form-input\"\n  [ngClass]=\"{\n    invalid:\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid,\n    pending: getInputNode().isPending()\n  }\"\n  [placeholder]=\"getInputNode().getProperty('placeHolder') || ''\"\n  [id]=\"getInputNode().getProperty('id')\"\n  [type]=\"getInputNode().getProperty('type')\"\n  [formControl]=\"$any(getInputNode().getControl())\"\n  [name]=\"getInputNode().getProperty('name')\"\n  [attr.readonly]=\"getInputNode().getProperty('readonly')\"\n/>\n\n<div class=\"hint\">\n  {{\n    getInputNode().getControl()?.touched && getInputNode().getControl()?.invalid\n      ? (getInputNode() | errorMessage)\n      : getInputNode().getProperty(\"hint\")\n  }}\n</div>\n", styles: [""], directives: [{ type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }], pipes: { "errorMessage": ErrorMessagePipe } });
DateInputComponent = __decorate([
    DynamicFormInput({ inputType: 'date' })
], DateInputComponent);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DateInputComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-date-input',
                    templateUrl: './date-input.component.html',
                    styleUrls: ['./date-input.component.css'],
                }]
        }], ctorParameters: function () { return []; } });

let NumberInputComponent = class NumberInputComponent extends InputComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
};
NumberInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: NumberInputComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NumberInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: NumberInputComponent, selector: "lib-number-input", usesInheritance: true, ngImport: i0, template: "<label\n  [attr.for]=\"getInputNode().getProperty('id')\"\n  class=\"d-form-label form-label\"\n  [ngClass]=\"{\n    required: getInputNode().getProperty('required'),\n    'invalid-label':\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid\n  }\"\n>\n  {{ getInputNode().getProperty(\"label\") }}\n</label>\n<input\n  class=\"form-control d-form-input\"\n  [ngClass]=\"{\n    invalid:\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid,\n    pending: getInputNode().isPending()\n  }\"\n  [placeholder]=\"getInputNode().getProperty('placeHolder') || ''\"\n  [id]=\"getInputNode().getProperty('id')\"\n  [type]=\"getInputNode().getProperty('type')\"\n  [formControl]=\"$any(getInputNode().getControl())\"\n  [name]=\"getInputNode().getProperty('name')\"\n  [attr.readonly]=\"getInputNode().getProperty('readonly')\"\n/>\n\n<div class=\"hint\">\n  {{\n    getInputNode().getControl()?.touched && getInputNode().getControl()?.invalid\n      ? (getInputNode() | errorMessage)\n      : getInputNode().getProperty(\"hint\")\n  }}\n</div>\n", styles: [""], directives: [{ type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }], pipes: { "errorMessage": ErrorMessagePipe } });
NumberInputComponent = __decorate([
    DynamicFormInput({ inputType: 'number' })
], NumberInputComponent);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: NumberInputComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-number-input',
                    templateUrl: './number-input.component.html',
                    styleUrls: ['./number-input.component.css'],
                }]
        }], ctorParameters: function () { return []; } });

let TextInputComponent = class TextInputComponent extends InputComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
};
TextInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TextInputComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TextInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: TextInputComponent, selector: "lib-text-input", usesInheritance: true, ngImport: i0, template: "<label\n  [attr.for]=\"getInputNode().getProperty('id')\"\n  class=\"d-form-label form-label\"\n  [ngClass]=\"{\n    required: getInputNode().getProperty('required'),\n    'invalid-label':\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid\n  }\"\n  >{{ getInputNode().getProperty(\"label\") }}</label\n>\n<input\n  class=\"form-control d-form-input\"\n  [ngClass]=\"{\n    invalid:\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid,\n    pending: getInputNode().isPending()\n  }\"\n  [placeholder]=\"getInputNode().getProperty('placeHolder') || ''\"\n  [id]=\"getInputNode().getProperty('id')\"\n  [type]=\"getInputNode().getProperty('type')\"\n  [formControl]=\"$any(getInputNode().getControl())\"\n  [name]=\"getInputNode().getProperty('name')\"\n  [attr.readonly]=\"getInputNode().getProperty('readonly')\"\n/>\n\n<div class=\"hint\">\n  {{\n    getInputNode().getControl()?.touched && getInputNode().getControl()?.invalid\n      ? (getInputNode() | errorMessage)\n      : getInputNode().getProperty(\"hint\")\n  }}\n</div>\n", styles: [""], directives: [{ type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }], pipes: { "errorMessage": ErrorMessagePipe } });
TextInputComponent = __decorate([
    DynamicFormInput({ inputType: 'TEXT' })
], TextInputComponent);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TextInputComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-text-input',
                    templateUrl: './text-input.component.html',
                    styleUrls: ['./text-input.component.css'],
                    // changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return []; } });

let CheckboxInputComponent = class CheckboxInputComponent extends InputComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
};
CheckboxInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: CheckboxInputComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CheckboxInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: CheckboxInputComponent, selector: "lib-checkbox-input", usesInheritance: true, ngImport: i0, template: "<div class=\"form-check\">\n  <input\n    class=\"form-check-input d-form-input d-form-check\"\n    [ngClass]=\"{\n      invalid:\n        getInputNode().getControl()?.touched &&\n        getInputNode().getControl()?.invalid\n    }\"\n    [id]=\"getInputNode().getProperty('id')\"\n    type=\"checkbox\"\n    [formControl]=\"$any(getInputNode().getControl())\"\n    [name]=\"getInputNode().getProperty('name')\"\n  />\n\n  <label\n    [attr.for]=\"getInputNode().getProperty('id')\"\n    class=\"d-form-label form-label form-check-label\"\n    [ngClass]=\"{\n      required: getInputNode().getProperty('required'),\n      'invalid-label':\n        getInputNode().getControl()?.touched &&\n        getInputNode().getControl()?.invalid\n    }\"\n    >{{ getInputNode().getProperty(\"label\") }}\n  </label>\n  <div class=\"hint\">\n    {{\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid\n        ? (getInputNode() | errorMessage)\n        : getInputNode().getProperty(\"hint\")\n    }}\n  </div>\n</div>\n", styles: [""], directives: [{ type: i2$1.CheckboxControlValueAccessor, selector: "input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]" }, { type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }], pipes: { "errorMessage": ErrorMessagePipe } });
CheckboxInputComponent = __decorate([
    DynamicFormInput({ inputType: 'checkbox' })
], CheckboxInputComponent);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: CheckboxInputComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-checkbox-input',
                    templateUrl: './checkbox-input.component.html',
                    styleUrls: ['./checkbox-input.component.css'],
                }]
        }], ctorParameters: function () { return []; } });

let NestedFormComponent = class NestedFormComponent extends InputComponent {
    constructor() {
        super();
        this.templateMap = new Map();
    }
    ngOnInit() { }
};
NestedFormComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: NestedFormComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NestedFormComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: NestedFormComponent, selector: "lib-nested-form", usesInheritance: true, ngImport: i0, template: "<fieldset [class]=\"'col-md-12 ' + getInputNode().getProperty('class')\">\n  <legend [class]=\"getInputNode().getProperty('legendClass')\">\n    {{ getInputNode().getProperty(\"legend\") }}\n  </legend>\n  <div class=\"row g-3\">\n    <ng-container *ngFor=\"let node of getInputNode().getChildren()\">\n      <div\n        [class]=\"'col-md-' + node.getProperty('width')\"\n        df-input-resolver\n        [inputNode]=\"node\"\n        [inputTemplatesMap]=\"templateMap\"\n      ></div>\n    </ng-container>\n  </div>\n</fieldset>\n", styles: [""], components: [{ type: InputResolverComponent, selector: "[df-input-resolver]", inputs: ["inputNode", "inputTemplatesMap"] }], directives: [{ type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }] });
NestedFormComponent = __decorate([
    DynamicFormInput({ inputType: 'COMPOSITE' })
], NestedFormComponent);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: NestedFormComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-nested-form',
                    templateUrl: './nested-form.component.html',
                    styleUrls: ['./nested-form.component.css'],
                }]
        }], ctorParameters: function () { return []; } });

class DataLoaderService {
    constructor(httpClient) {
        this.httpClient = httpClient;
        this.dataSources = new Map(); //used to return the same observable to stop async pipe from sending multiple http requests
    }
    load(dataSource) {
        if (dataSource instanceof URL) {
            if (!this.dataSources.get(dataSource.href)) {
                this.dataSources.set(dataSource.href, this.httpClient.get(dataSource.href));
            }
            return this.dataSources.get(dataSource.href) || of([]);
        }
        else if (Array.isArray(dataSource)) {
            return of(dataSource);
        }
        else {
            return dataSource;
        }
    }
}
DataLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DataLoaderService, deps: [{ token: i1.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
DataLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DataLoaderService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DataLoaderService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i1.HttpClient }]; } });

let RadioButtonsInputComponent = class RadioButtonsInputComponent extends InputComponent {
    constructor(dataLoader) {
        super();
        this.dataLoader = dataLoader;
    }
    ngOnInit() { }
};
RadioButtonsInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: RadioButtonsInputComponent, deps: [{ token: DataLoaderService }], target: i0.ɵɵFactoryTarget.Component });
RadioButtonsInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: RadioButtonsInputComponent, selector: "lib-radio-buttons-input", providers: [DataLoaderService], usesInheritance: true, ngImport: i0, template: "<fieldset class=\"col-md-12\">\n  <legend class=\"form-label d-form-label radio-legend\">\n    {{ getInputNode().getProperty(\"legend\") }}\n  </legend>\n  <div class=\"row g-3\">\n    <div\n      [class]=\"'col-md-' + getInputNode().getProperty('inputWidth')\"\n      *ngFor=\"\n        let opt of dataLoader.load(getInputNode().getProperty('dataSource'))\n          | async;\n        let i = index\n      \"\n    >\n      <div class=\"form-check\">\n        <input\n          class=\"form-check-input d-form-input\"\n          [id]=\"getInputNode().getProperty('id') + i\"\n          type=\"radio\"\n          [formControl]=\"$any(getInputNode().getControl())\"\n          [value]=\"\n            getInputNode().getProperty('bindValue')\n              ? opt[getInputNode().getProperty('bindValue')]\n              : opt\n          \"\n          [name]=\"getInputNode().getProperty('name')\"\n        />\n\n        <label\n          class=\"form-check-label d-form-label\"\n          [attr.for]=\"getInputNode().getProperty('id') + i\"\n        >\n          {{ opt[getInputNode().getProperty(\"bindLabel\")] }}\n        </label>\n\n        <!-- <div class=\"hint\">\n            Lorem ipsum dolor sit amet consectetur adipisicing elit. Quisquam\n            hic\n          </div> -->\n      </div>\n    </div>\n  </div>\n</fieldset>\n", styles: [""], directives: [{ type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2$1.RadioControlValueAccessor, selector: "input[type=radio][formControlName],input[type=radio][formControl],input[type=radio][ngModel]", inputs: ["name", "formControlName", "value"] }, { type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }], pipes: { "async": i2.AsyncPipe } });
RadioButtonsInputComponent = __decorate([
    DynamicFormInput({ inputType: 'radio_buttons' })
], RadioButtonsInputComponent);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: RadioButtonsInputComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-radio-buttons-input',
                    templateUrl: './radio-buttons-input.component.html',
                    styleUrls: ['./radio-buttons-input.component.css'],
                    providers: [DataLoaderService],
                }]
        }], ctorParameters: function () { return [{ type: DataLoaderService }]; } });

let SelectInputComponent = class SelectInputComponent extends InputComponent {
    constructor(dataLoader) {
        super();
        this.dataLoader = dataLoader;
    }
    ngOnInit() {
        this.defaultValueIndex =
            this.getInputNode().getProperty('defaultValueIndex');
        this.dataLoader
            .load(this.getInputNode().getProperty('dataSource'))
            .toPromise()
            .then((data) => {
            this.options = data;
            if (this.defaultValueIndex !== undefined) {
                this.defaultValue = this.options[this.defaultValueIndex];
                this.getInputNode().getControl().setValue(this.defaultValue, false);
            }
        });
    }
};
SelectInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: SelectInputComponent, deps: [{ token: DataLoaderService }], target: i0.ɵɵFactoryTarget.Component });
SelectInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: SelectInputComponent, selector: "lib-select-input", providers: [DataLoaderService], usesInheritance: true, ngImport: i0, template: "<label\n  [attr.for]=\"getInputNode().getProperty('id')\"\n  class=\"d-form-label form-label\"\n  [ngClass]=\"{\n    required: getInputNode().getProperty('required'),\n    'invalid-label':\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid\n  }\"\n  >{{ getInputNode().getProperty(\"label\") }}\n</label>\n\n<select\n  class=\"form-select d-form-input\"\n  [ngClass]=\"{\n    invalid:\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid,\n    pending: getInputNode().isPending()\n  }\"\n  [id]=\"getInputNode().getProperty('id')\"\n  [formControl]=\"$any(getInputNode().getControl())\"\n  [name]=\"getInputNode().getProperty('name')\"\n  [compareWith]=\"getInputNode().getProperty('compareWith')\"\n>\n  <option\n    *ngFor=\"\n      let opt of dataLoader.load(getInputNode().getProperty('dataSource'))\n        | async\n    \"\n    [ngValue]=\"\n      opt[getInputNode().getProperty('bindValue')]\n        ? opt[getInputNode().getProperty('bindValue')]\n        : opt\n    \"\n  >\n    {{ opt[getInputNode().getProperty(\"bindLabel\")] }}\n  </option>\n</select>\n<div class=\"hint\">\n  {{\n    getInputNode().getControl()?.touched && getInputNode().getControl()?.invalid\n      ? (getInputNode() | errorMessage)\n      : getInputNode().getProperty(\"hint\")\n  }}\n</div>\n", styles: [""], directives: [{ type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2$1.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2$1.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { type: i2$1.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }], pipes: { "async": i2.AsyncPipe, "errorMessage": ErrorMessagePipe } });
SelectInputComponent = __decorate([
    DynamicFormInput({ inputType: 'select' })
], SelectInputComponent);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: SelectInputComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-select-input',
                    templateUrl: './select-input.component.html',
                    styleUrls: ['./select-input.component.css'],
                    providers: [DataLoaderService],
                }]
        }], ctorParameters: function () { return [{ type: DataLoaderService }]; } });

class DynamicFormModule {
    // todo
    // replace ith with forRoot and forChild pattern
    static register(entities) {
        entities.forEach((entity) => {
            var _a;
            const name = (_a = FormMetaData.get(entity.prototype)) === null || _a === void 0 ? void 0 : _a.get('name');
            if (name)
                EntityRegistry.add(name, entity);
        });
        return {
            ngModule: DynamicFormModule,
            providers: [
                FormEntityProcessorService,
                EntityRegistry,
                InputProcessorService,
            ],
        };
    }
}
DynamicFormModule.defaultInputComponents = [
    TextInputComponent,
    NumberInputComponent,
    DateInputComponent,
    CheckboxInputComponent,
    NestedFormComponent,
    RadioButtonsInputComponent,
    SelectInputComponent,
];
DynamicFormModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DynamicFormModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DynamicFormModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DynamicFormModule, declarations: [DynamicFormComponent,
        ErrorMessagePipe,
        InputComponent,
        InputTemplateDirective,
        InputResolverComponent,
        InputAnchorDirective,
        TextInputComponent,
        NumberInputComponent,
        DateInputComponent,
        CheckboxInputComponent,
        NestedFormComponent,
        RadioButtonsInputComponent,
        SelectInputComponent,
        ButtonTemplateDirective], imports: [CommonModule, FormsModule, ReactiveFormsModule], exports: [DynamicFormComponent,
        InputTemplateDirective,
        InputComponent,
        ButtonTemplateDirective,
        ErrorMessagePipe] });
DynamicFormModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DynamicFormModule, imports: [[CommonModule, FormsModule, ReactiveFormsModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DynamicFormModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DynamicFormComponent,
                        ErrorMessagePipe,
                        InputComponent,
                        InputTemplateDirective,
                        InputResolverComponent,
                        InputAnchorDirective,
                        TextInputComponent,
                        NumberInputComponent,
                        DateInputComponent,
                        CheckboxInputComponent,
                        NestedFormComponent,
                        RadioButtonsInputComponent,
                        SelectInputComponent,
                        ButtonTemplateDirective,
                    ],
                    imports: [CommonModule, FormsModule, ReactiveFormsModule],
                    exports: [
                        DynamicFormComponent,
                        InputTemplateDirective,
                        InputComponent,
                        ButtonTemplateDirective,
                        ErrorMessagePipe
                    ],
                }]
        }] });

function FormEntity(formSpec) {
    return function (constructor) {
        FormMetaData.add(formSpec, constructor);
        return class extends constructor {
            constructor() {
                super(...arguments);
                this.valueSetter = (value) => {
                    console.warn('implement smart setter for null value');
                    if (value == null) {
                    }
                    if (value instanceof Object) {
                        for (const key in this) {
                            if (value[key] != undefined) {
                                //@ts-ignore
                                this[key] = value[key];
                            }
                        }
                    }
                };
            }
        };
    };
}

function TextInput(specs) {
    return function (target, propertyKey) {
        InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: InputTypes.TEXT }), target, propertyKey);
    };
}
function NumberInput(specs) {
    return function (target, propertyKey) {
        specs.type = 'number';
        InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: InputTypes.NUMBER, type: 'number' }), target, propertyKey);
    };
}
function DateInput(specs) {
    return function (target, propertyKey) {
        InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: InputTypes.DATE }), target, propertyKey);
    };
}
function SelectInput(specs) {
    return function (target, propertyKey) {
        InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: InputTypes.SELECT }), target, propertyKey);
    };
}
function CheckboxInput(specs) {
    return function (target, propertyKey) {
        InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: InputTypes.CHECKBOX }), target, propertyKey);
    };
}
function RadioGroupInput(specs) {
    return function (target, propertyKey) {
        InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: InputTypes.RADIO_BUTTONS }), target, propertyKey);
    };
}
function NestedFormEntity(specs) {
    return function (target, propertyKey) {
        InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: InputTypes.COMPOSITE }), target, propertyKey);
    };
}
function CustomInput(specs) {
    return function (target, propertyKey) {
        InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: specs.inputType.toUpperCase() }), target, propertyKey);
    };
}
// TODO make it replacement for custominput and name it dynamic form input
// todo rename dynmic form input to dynamic form input component or form input component
// mark the other as depricated
// export function DynamicInput<S extends InputSpec>(specs: S){
//   return function (target: any, propertyKey: string) {
//     InputsMetaData.add(
//       { ...specs, inputType: specs.inputType.toUpperCase() },
//       target,
//       propertyKey
//     );
//   };
// }

function Reset(meta) {
    return function (constructor) {
        ActionsMetaData.add(Object.assign(Object.assign({}, meta), { type: 'reset' }), constructor);
        return class extends constructor {
        };
    };
}

function Submit(meta) {
    return function (constructor) {
        ActionsMetaData.add(Object.assign(Object.assign({}, meta), { type: 'submit' }), constructor);
        return class extends constructor {
        };
    };
}

function Button(meta) {
    return function (constructor) {
        ActionsMetaData.add(Object.assign(Object.assign({}, meta), { type: 'button' }), constructor);
        return class extends constructor {
        };
    };
}

function Required(errConfig) {
    return function (target, propertyKey) {
        ValidationsMetaData.add({
            errorName: 'required',
            errorMessage: errConfig.message,
            validatorFn: Validators.required,
        }, target, propertyKey);
    };
}

function RequiredTrue(errConfig) {
    return function (target, propertyKey) {
        ValidationsMetaData.add({
            errorName: 'required',
            errorMessage: errConfig.message,
            validatorFn: Validators.requiredTrue,
        }, target, propertyKey);
    };
}

function Max(errConfig) {
    return function (target, propertyKey) {
        ValidationsMetaData.add({
            errorName: 'max',
            errorMessage: errConfig.message,
            validatorFn: Validators.max(errConfig.maxValue),
        }, target, propertyKey);
    };
}

function Min(errConfig) {
    return function (target, propertyKey) {
        ValidationsMetaData.add({
            errorName: 'min',
            errorMessage: errConfig.message,
            validatorFn: Validators.min(errConfig.minValue),
        }, target, propertyKey);
    };
}

function MaxLength(errConfig) {
    return function (target, propertyKey) {
        ValidationsMetaData.add({
            errorName: 'maxlength',
            errorMessage: errConfig.message,
            validatorFn: Validators.maxLength(errConfig.maxlength),
        }, target, propertyKey);
    };
}

function MinLength(errConfig) {
    return function (target, propertyKey) {
        ValidationsMetaData.add({
            errorName: 'minlength',
            errorMessage: errConfig.message,
            validatorFn: Validators.minLength(errConfig.minlength),
        }, target, propertyKey);
    };
}

function Pattern(errConfig) {
    return function (target, propertyKey) {
        ValidationsMetaData.add({
            errorName: 'pattern',
            errorMessage: errConfig.message,
            validatorFn: Validators.pattern(errConfig.pattern),
        }, target, propertyKey);
    };
}

function Email(errConfig) {
    return function (target, propertyKey) {
        ValidationsMetaData.add({
            errorName: 'email',
            errorMessage: errConfig.message,
            validatorFn: Validators.email,
        }, target, propertyKey);
    };
}

function MaxDate(errConfig) {
    return function (target, propertyKey) {
        ValidationsMetaData.add({
            errorName: 'maxDate',
            errorMessage: errConfig.message,
            validatorFn: DateValidation.max(errConfig.maxDate),
        }, target, propertyKey);
    };
}
function MinDate(errConfig) {
    return function (target, propertyKey) {
        ValidationsMetaData.add({
            errorName: 'minDate',
            errorMessage: errConfig.message,
            validatorFn: DateValidation.min(errConfig.minDate),
        }, target, propertyKey);
    };
}
class DateValidation {
    static max(value) {
        const max = DateValidation.parseDate(value);
        return (control) => {
            const dateVal = DateValidation.parseDate(control.value);
            if (dateVal <= max)
                return null;
            else
                return { maxDate: true };
        };
    }
    static min(value) {
        const min = DateValidation.parseDate(value);
        return (control) => {
            const dateVal = DateValidation.parseDate(control.value);
            if (dateVal >= min)
                return null;
            else
                return { minDate: true };
        };
    }
    static parseDate(date) {
        if (date == null || (typeof date == 'string' && !isNaN(Date.parse(date)))) {
            // empty strings gives invalid date so if empty string
            // is passed as argument its converted to zero date since epoch
            return new Date(date == '' ? 0 : date);
        }
        else if (date instanceof Date)
            return date;
        else
            throw new Error('invalid date format ' + date);
    }
}

function CrossValidation(spec) {
    // return (target) => {
    //   const crossValidationMeta = Reflect.getMetadata(
    //     CROSS_VALIDATION_METADATA_KEY,
    //     target
    //   );
    //   if (!crossValidationMeta) {
    //     return Reflect.defineMetadata(
    //       CROSS_VALIDATION_METADATA_KEY,
    //       [spec],
    //       target
    //     );
    //   } else {
    //     crossValidationMeta.push(spec);
    //   }
    // };
    return function (constructor) {
        CrossValidationMeta.add(spec, constructor);
        return class extends constructor {
        };
    };
}

function AsyncValidation(specs) {
    return function (target, propertyKey) {
        AsyncValidationMeta.add(specs, target, propertyKey);
    };
}

/*
 * Public API Surface of decorator-driven-dynamic-form
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AsyncValidation, Button, ButtonTemplateDirective, CheckboxInput, ContextOverride, CrossValidation, CustomInput, DateInput, DateValidation, DynamicFormComponent, DynamicFormContextService, DynamicFormInput, DynamicFormModule, Email, ErrorMessagePipe, FormEntity, FormEntityProcessorService, ID_META_KEY, Id, InputComponent, InputTemplateDirective, InputTypes, Max, MaxDate, MaxLength, Min, MinDate, MinLength, NestedFormEntity, NumberInput, ON_CONTEXT_META_KEY, Pattern, RadioGroupInput, Required, RequiredTrue, Reset, SelectInput, Submit, TextInput, USE_CONTEXT_META_KEY, UpdateStrategy, UseContext };
//# sourceMappingURL=ddd-form.js.map
