import 'reflect-metadata';
export declare type UseContext = 'CREATE' | 'UPDATE' | 'NONE' | 'SEARCH' | 'PATCH' | string;
export declare const ID_META_KEY: unique symbol;
export declare const ON_CONTEXT_META_KEY: unique symbol;
export declare const USE_CONTEXT_META_KEY: unique symbol;
export declare type ContextSpecs = {
    context: string;
    properties: OverridableProperties;
};
export declare type OverridableProperties = {
    readonly?: boolean;
    disabled?: boolean;
    class?: string;
    [x: string]: any;
};
/**
 * used to override some attributes in some context
 * a filed may be disabled in a context and enabled in another
 * or may have different style and so on ..
 *
 * @param specs {context: string;
  properties: OverridableProperties;}
 * @returns none
 */
export declare function ContextOverride(specs: {
    context: string;
    properties: OverridableProperties;
}): (target: any, propertyKey: string) => void;
export declare function Id(): (target: any, propertyKey: string) => void;
/**
 * used to bind field existence with context variable
 * the field will only appear if its context equals form context
 * if no context is specified to field it appears in all contexts
 *
 * @param ctx string
 * @returns none
 */
export declare function UseContext(ctx: string): (target: any, propertyKey: string) => void;
