import { AbstractControl, AsyncValidatorFn, ValidationErrors } from '@angular/forms';
import { Observable } from 'rxjs';
export declare const ASYNC_VALIDATION_METADATA_KEY: unique symbol;
export interface AsyncValidator {
    validate(control: AbstractControl): Promise<ValidationErrors> | Observable<ValidationErrors>;
}
export interface InjectableAsyncValidatorProvider {
    provider: any;
}
export declare type AsyncValidationSpec = {
    validator: AsyncValidator | AsyncValidatorFn | InjectableAsyncValidatorProvider;
    errorMessage: string;
    errorName: string;
};
export declare class AsyncValidationMeta {
    static add(validationSpec: AsyncValidationSpec, target: any, propertyKey: string): void;
    static get(target: any, propertyKey: string): AsyncValidationSpec[] | undefined;
    static getValidatorsAndErrorMap(target: any, propertyKey: string): {
        validators: any[];
        errorMap: Map<string, string>;
    };
}
