import { AfterContentInit, EventEmitter, OnInit, QueryList, SimpleChanges, TemplateRef } from '@angular/core';
import { FormValueTransformer } from '../../../core/models/types/forms/form-value-transformer';
import { InputNode } from '../../../core/models/types/inputs/input-node';
import { EntityRegistry } from '../../../core/services/entity-registry/entity-registry.service';
import { DynamicFormContextService } from '../../../core/services/form-context/dynamic-form-context.service';
import { FormEntityProcessorService } from '../../../core/services/form-entity-processor/form-entity-processor.service';
import { ButtonTemplateDirective } from '../../directives/button-template/button-template.directive';
import { InputTemplateDirective } from '../../directives/input-template/input-template.directive';
import { UseContext } from '../../../core/models/decorators/context/form-context';
import { FormController } from '../../../core/models/types/inputs/form-controller';
import * as i0 from "@angular/core";
export declare class DynamicFormComponent implements OnInit, AfterContentInit, FormController {
    private formEntityProcessorService;
    private dynamicFormContextService;
    private entityRegistry;
    inputTree: InputNode;
    formEntity: any;
    entityName: string;
    initialValue: any;
    useContext: UseContext;
    valueTransformer?: FormValueTransformer<any, any>;
    includeDisabled: boolean;
    submitEvent: EventEmitter<any>;
    changEvent: EventEmitter<any>;
    buttonClickEvent: EventEmitter<any>;
    inputTemplateQueryList: QueryList<InputTemplateDirective>;
    buttonTemplateQueryList: QueryList<ButtonTemplateDirective>;
    inputTemplateMap: Map<string, TemplateRef<any>>;
    constructor(formEntityProcessorService: FormEntityProcessorService, dynamicFormContextService: DynamicFormContextService, entityRegistry: EntityRegistry);
    ngAfterContentInit(): void;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onSubmit(v: any): void;
    onClick(action: any): void;
    get formValue(): any;
    markAllAsTouched(): void;
    markAsTouched(path: string): void;
    markAsInvalid(path?: string, errConfig?: {
        errName: string;
        errMessage: string;
    }): void;
    markFieldAsInvalid(path: string, errConfig: {
        errName: string;
        errMessage: string;
    }): void;
    disable(path: string): void;
    enable(path: string): void;
    setReadonly(path: string): void;
    unsetReadonly(path: string): void;
    getRowValue(): any;
    getValue(): any;
    fireAction(id: string): void;
    reset(value?: any, emitEvent?: boolean): void;
    patch(value?: any, emitEvent?: boolean): void;
    getName(): string;
    isValid(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicFormComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DynamicFormComponent, "d-form", never, { "entityName": "entityName"; "initialValue": "initialValue"; "useContext": "useContext"; "valueTransformer": "valueTransformer"; "includeDisabled": "includeDisabled"; }, { "submitEvent": "submitEvent"; "changEvent": "changeEvent"; "buttonClickEvent": "buttonClickEvent"; }, ["inputTemplateQueryList", "buttonTemplateQueryList"], ["*"]>;
}
